; Theorarm library
; Copyright (C) 2009 Robin Watts for Pinknoise Productions Ltd

	AREA	|.text|, CODE, READONLY

	EXPORT	oc_sb_run_unpack
	EXPORT	oc_block_run_unpack

	IMPORT	theorapackB_lookARM
	IMPORT	oggpack_adv

oc_sb_run_unpack
	STMFD	r13!,{r0,r4,r14}

	MOV	r1, #18
	BL	theorapackB_lookARM
	MOV	r1, #1		; r1 = adv = 1
	MVN	r2, #0		; r2 = sub = -1
	TST	r0, #0x20000	; if (bits&0x20000)
	MOVNE	r1, #3		;   r1 = adv = 3
	MOVNE	r2, #2		;   r2 = sub = 2
	TSTNE	r0, #0x10000	;   if (bits&0x10000)
	MOVNE	r1, #4		;     r1 = adv = 4
	MOVNE	r2, #8		;     r2 = sub = 8
	TSTNE	r0, #0x08000	;     if (bits&0x08000)
	MOVNE	r1, #6		;       r1 = adv = 6
	MOVNE	r2, #50		;       r2 = sub = 50
	TSTNE	r0, #0x04000	;       if (bits&0x04000)
	MOVNE	r1, #8		;         r1 = adv = 8
	MOVNE	r2, #230	;         r2 = sub = 230
	TSTNE	r0, #0x02000	;         if (bits&0x02000)
	MOVNE	r1, #10		;           r1 = adv = 10
	ADDNE	r2, r2, #974-230;           r2 = sub = 974
	TSTNE	r0, #0x01000	;           if (bits&0x01000)
	MOVNE	r1, #18		;             r1 = adv = 18
	LDRNE	r2, =258014	;             r2 = sub = 258014
	RSB	r4, r1, #18
	RSB	r4, r2, r0, LSR r4; (r4 = bits>>(18-adv))-sub
	LDR	r0, [r13],#4
	BL	oggpack_adv
	MOV	r0, r4

	LDMFD	r13!,{r4,PC}

oc_block_run_unpack
	STMFD	r13!,{r0,r4,r14}

	MOV	r1, #9
	BL	theorapackB_lookARM
	MOV	r1, #2		; r1 = adv = 2
	MVN	r2, #0		; r2 = sub = -1
	TST	r0, #0x100	; if (bits&0x100)
	MOVNE	r1, #3		;   r1 = adv = 3
	MOVNE	r2, #1		;   r2 = sub = 1
	TSTNE	r0, #0x080	;   if (bits&0x080)
	MOVNE	r1, #4		;     r1 = adv = 4
	MOVNE	r2, #7		;     r2 = sub = 7
	TSTNE	r0, #0x040	;     if (bits&0x040)
	MOVNE	r1, #6		;       r1 = adv = 6
	MOVNE	r2, #49		;       r2 = sub = 49
	TSTNE	r0, #0x020	;       if (bits&0x020)
	MOVNE	r1, #7		;         r1 = adv = 8
	MOVNE	r2, #109	;         r2 = sub = 109
	TSTNE	r0, #0x010	;         if (bits&0x010)
	MOVNE	r1, #9		;           r1 = adv = 10
	ADDNE	r2, r2, #481-109;           r2 = sub = 481
	RSB	r4, r1, #9
	RSB	r4, r2, r0, LSR r4; (r4 = bits>>(9-adv))-sub
	LDR	r0, [r13],#4
	BL	oggpack_adv
	MOV	r0, r4

	LDMFD	r13!,{r4,PC}

	END
